﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WizardSample.Uc;

namespace WizardSample
{
    public partial class WizardHost : Form
    {
        public UserControl CurrentStep { get; set; }
        public IList<UserControl> Steps { get; set; }

        public WizardHost()
        {
            InitializeComponent();

            this.BuildStepsList();

            this.StartWizard();
        }

        private void StartWizard()
        {
            this.ApplyStep(this.Steps[0]);
        }

        private void ApplyStep(UserControl step)
        {
            if (step == null) return;

            if (this.panel1.Controls.Count > 0)
            {
                this.panel1.Controls.Clear();
            }
            this.panel1.Controls.Add(step);
            this.CurrentStep = step;
            this.ManageButtons();
        }

        /// <summary>
        /// Construit la liste des étapes du wizard.
        /// </summary>
        private void BuildStepsList()
        {
            UcStep1 step1 = new UcStep1();
            UcStep2 step2 = new UcStep2();
            UcStep3 step3 = new UcStep3();

            this.Steps = new List<UserControl>();
            this.Steps.Add(step1);
            this.Steps.Add(step2);
            this.Steps.Add(step3);
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            int i = this.Steps.IndexOf(this.CurrentStep);
            if (i < this.Steps.Count-1)
            {
                this.ApplyStep(this.Steps[i + 1]);
            }
        }

        private void btnPrev_Click(object sender, EventArgs e)
        {
            int i = this.Steps.IndexOf(this.CurrentStep);
            if (i > 0)
            {
                this.ApplyStep(this.Steps[i - 1]);
            }
        }

        private void ManageButtons()
        {
            int i = this.Steps.IndexOf(this.CurrentStep);

            btnEnd.Visible = false;
            btnPrev.Visible = false;
            btnNext.Visible = false;
            int last = this.Steps.Count - 1;

            if (i == 0)
            {
                btnNext.Visible = true;
            }
            else if (i == this.Steps.Count - 1)
            {
                btnEnd.Visible = true;
            }
            else
            {
                btnPrev.Visible = true;
                btnNext.Visible = true;
            }
        }

        private void btnEnd_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
